package colorProxy.impl;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.JFrame;
import javax.swing.JPanel;

import colorProxy.ServiceInterface;

public class Service implements ServiceInterface {

	private String copeurl = "http://localhost:8080/axis/services/copeserver";

	private String serviceurl = "http://localhost:8080/axis/services/colorservice";

	private String name = "Color Service";

	protected File icon;

	private long id;

	private String copeIP;

	JPanel colorPanel;

	JFrame main;

	public Service() {
		main = new JFrame("ColorPanel");
		colorPanel = new JPanel();
		colorPanel.setPreferredSize(new Dimension(400, 400));
	}
	
	/************************************
	 * 
	 * Custom stuff
	 *
	 ************************************/
	public void subscribe() {
		// getting ip from cope server
		copeIP = (String) Communicator.sendRequest(copeurl, "getIp", new Object[]{});
		// subscribing with correct IP
//		Communicator.sendRequest(serviceurl, "subscribe", new Object[] { "http://" + copeIP + ":8080/axis/services/colorproxy" });
		Communicator.sendRequest(serviceurl, "subscribe", new Object[] { "http://localhost:8080/axis/services/colorproxy" });
	}

	public void unsubscribe() {
//		Communicator.sendRequest(serviceurl, "unsubscribe", new Object[] { "http://" + copeIP + ":8080/axis/services/colorproxy" });
		Communicator.sendRequest(serviceurl, "unsubscribe", new Object[] { "http://localhost:8080/axis/services/colorproxy" });
	}
	
	public void event(String description, Object oldValue, Object newValue) {
		System.out.println(getName() + " recieved command: event");
	}

	public void openInterface() {
		System.out.println(getName() + " recieved command: openInterface");
		main.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				unsubscribe();
			}
			public void windowOpened(WindowEvent e) {
				subscribe();
			}
		});
		main.setContentPane(colorPanel);
		main.pack();
		main.setVisible(true);
	}

	public Properties getDescription() {
		System.out.println(getName() + " recieved command: getDescription");
		Properties props = new Properties();
		props.put("connection.terminating.1", "weatherConnection");
		props.put("connection.terminating.2", "rgbConnection");
		
		return props;
	}

	public void connect(String description, String source, String target) {
		System.out.println(getName() + " received command: connect");
	}

	public void disconnect(String description, String source, String target) {
		System.out.println(getName() + " received command: disconnect");
	}

	public void setID(long id) {
		System.out.println(getName() + " received command: setID");
		this.id = id;
	}

	public void ping() {
		System.out.print(getName() + " received ping");
		Communicator.sendRequest(copeurl, "pong", new Object[] { new Long(id) });
	}

	public void reRegisterWithCope() {
		System.out.println(getName() + " received command: reRegisterWithCope");
		Communicator.sendRequest(copeurl, "reRegisterService", new Object[] { new Long(id) });
	}

	public String getName() {
		return name;
	}

	public void setURL(String url) {
		serviceurl = url;
	}

	public String getURL() {
		return serviceurl;
	}
	
	public String getIconPath() {
		try {
			if (icon.exists())
				icon.delete();

			icon.createNewFile();

			FileInputStream fis = (FileInputStream) getClass()
					.getResourceAsStream("/icon.png");
			FileOutputStream fos = new FileOutputStream(icon);
			int b;
			while ((b = fis.read()) != -1) {
				fos.write(b);
			}

			fos.flush();
			fos.close();

			fis.close();

			if (icon != null)
				return icon.getPath();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

	public void setRGB(int r, int g, int b) {
		System.out.println("Updating color to " + r + ", " + g + ", " + b);
		colorPanel.setBackground(new Color(r, g, b));
		colorPanel.updateUI();
	}
}
