package colorService.impl;

import java.util.ArrayList;
import java.util.List;

import colorService.ServiceInterface;

public class Service implements ServiceInterface {

	List subscribers = new ArrayList();

	public Service() {
	}

	public void setRGB(int r, int g, int b) {
		for (int i = 0; i < subscribers.size(); i++) {

			final String endpoint = (String) subscribers.get(i);
			final int r2 = adjust(r);
			final int g2 = adjust(g);
			final int b2 = adjust(b);
			new Thread(new Runnable() {
				public void run() {
					System.out.println("Color Service Updating: " + endpoint);
					Communicator.sendRequest(endpoint, "setRGB", new Object[] { new Integer(r2), new Integer(g2), new Integer(b2) });
				}
			}).start();
		}
	}

	public void setWeatherData(String[] headers, String[] values) {
		System.out.println("Setting color based on weather data at Color Service!");
		int[] rgb = new int[]{255, 0, 0};
		
		int index = 0;
		for (int i = 0; i < values.length; i++) {
			try {
				int x = (int) Double.parseDouble(values[i]);
				rgb[index++] = x;
				if(index == 3) {
					break;
				}
			} catch (Exception parsingFailed) { }
		}
		setRGB(rgb[0], rgb[1], rgb[2]);
	}
	
	private int adjust(int a) {
		a = Math.abs(a);
		
		if (a > 255)
			return (int) (Math.pow(255, 2) / a);

		return a;
	}

	public void subscribe(String address) {
		if (!subscribers.contains(address)) {
			subscribers.add(address);
		}
	}

	public void unsubscribe(String address) {
		if (subscribers.contains(address)) {
			subscribers.remove(address);
		}
	}
}
