package copeServer.impl.composition;

import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;

public class CompositionRegistry extends AbstractListModel{
	
	private List compositions = new ArrayList();
	
	public CompositionRegistry(){
		
	}
	

	/**
	 * Add a Composition
	 * @param relation
	 */
	public void addComposition(Composition composition){
		if(!compositions.contains(composition)){
			compositions.add(composition);
			//composition.addPropertyChangeListener(this);
			fireIntervalAdded(this, 0, getSize());
			System.out.println("Added new composition: "+composition);
		} else{
			System.out.println("ERROR ! Trying to add composition that is allready there.");
		}
	}
	
	/**
	 * Remove a Composition
	 * @param relation
	 */
	public void removeComposition(Composition composition){
		if(compositions.contains(composition)){
			compositions.remove(composition);
			//composition.removePropertyChangeListener(this);
			fireIntervalRemoved(this, 0, getSize());
			System.out.println("Removed composition "+composition);
		} else{
			System.out.println("ERROR ! Trying to remove composition that is not there.");
		}
	}
	
	public int getSize() {
		return compositions.size();
	}

	public Object getElementAt(int arg0) {
		return compositions.get(arg0);
	}
	
}
