package copeServer.impl.connection;

import java.net.URL;
import java.util.HashMap;
import java.util.Properties;

import javax.xml.namespace.QName;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;

public class SOAPServiceManaged implements ServiceConnectionInterface {

	private String url = "http://localhost:8080/axis/services/";
	
	public SOAPServiceManaged(String name) {
		this.url = this.url+name;
	}

	public void setURL(String url) {
		this.url = url;
	}

	public void ping() {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("ping"));
			
			call.invoke(new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void connect(String description, String source, String target) {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("connect"));
			
			call.invoke(new Object[]{description, source, target});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void disconnect(String description, String source, String target) {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("disconnect"));
			
			call.invoke(new Object[]{description, source, target});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void setID(long id) {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("setID"));

			call.invoke(new Object[]{new Long(id)});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void event(String description, Object oldValue, Object newValue) {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("event"));

			call.invoke(new Object[]{oldValue, newValue});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public Properties getDescription() {
		Properties props = null;
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("getDescription"));
			HashMap map = (HashMap) call.invoke(new Object[]{});
			props = new Properties();
			props.putAll(map);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		if(props == null)
			props = new Properties();
		
		return props;
	}

	public void openInterface() {
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("openInterface"));
			call.invoke(new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getName() {
		String ret = null;
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("getName"));

			ret = (String) call.invoke(new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ret;
	}

	public String getURL() {
		String ret = null;
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("getURL"));

			ret = (String) call.invoke(new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ret;
	}

	public String getIconPath() {
		String ret = null;
		try {
			String endpoint = url;
			
			Service  service = new Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("getIconPath"));

			ret = (String) call.invoke(new Object[]{});
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ret;
	}

}
