package copeServer.impl.discovery;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

public abstract class AbstractDiscovery {
	
	private String[] urls = new String[10]; //returned urls of discovery
	
	PropertyChangeSupport pcs;
	
	public void newURL(String url){
		String oldURL = urls[0];
		for (int i = urls.length; i != 1; i--) {
			urls[i-1] = urls[i-2];
		}
		urls[0] = url;
		firePropertyChangeEvent("url", oldURL, url);
		System.out.println("New URL discovered.");
	}
	
	public String[] getURLs(){
		return urls;
	}
	
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		if (pcs == null) {
			pcs = new PropertyChangeSupport(this);
		}
		pcs.addPropertyChangeListener(listener);
	}
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		if (pcs != null) {
			pcs.removePropertyChangeListener(listener);
		}
	}
	
	protected void firePropertyChangeEvent(String propertyName, Object oldValue, Object newValue) {
		if (pcs == null || oldValue == newValue || (oldValue != null && oldValue.equals(newValue))) {
			return;
		}
		pcs.firePropertyChange(propertyName, oldValue, newValue);
	}
	
}
