package copeServer.impl.gui;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;

import javax.swing.JPanel;

import copeServer.impl.composition.CompositionRegistry;

public class FavoritesPanel extends JPanel{

	protected Image bgImage = null;
	
	private Model model;
	private CompositionRegistry compositionRegistry;
	
	public FavoritesPanel(Model model, CompositionRegistry compositionRegistry) {
		this.model = model;
		this.compositionRegistry = compositionRegistry;

		MediaTracker mt = new MediaTracker(this);                
		bgImage = Toolkit.getDefaultToolkit().getImage("COPE/favoritesback.jpg");
		mt.addImage(bgImage, 0);
		try
		{
			mt.waitForAll();
		}
		catch (InterruptedException e)
		{
			e.printStackTrace();
		}
		
	}
	
	protected void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		if(bgImage != null)
		{
			int imwidth = bgImage.getWidth(null);
			int imheight = bgImage.getHeight(null);
			
			if((imwidth > 0) && (imheight > 0))
			{
				for(int y = 0; y<getHeight(); y+=imheight)
				{
					for(int x = 0; x<getWidth(); x+=imwidth)
					{
						g.drawImage(bgImage, x, y, null);
					}
				}
			}
		}
	}

}
