package copeServer.impl.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class MenuPanel extends JPanel implements PropertyChangeListener, MouseListener{

	private Model model;
	
	public ImageIcon discoverybutton = new ImageIcon("COPE/discoverybutton.jpg");
	public ImageIcon favoritesbutton = new ImageIcon("COPE/favoritesbutton.jpg");
	public ImageIcon myservicesbutton = new ImageIcon("COPE/myservicesbutton.jpg");
	
	private JLabel discovery = new JLabel(discoverybutton);
	private JLabel favorites = new JLabel(favoritesbutton);
	private JLabel services = new JLabel(myservicesbutton);
	
	public MenuPanel(Model model) {
		this.model = model;
		this.setLayout(new FlowLayout());
		this.model.addPropertyChangeListener(this);
		setFalse();
		discovery.setBackground(Color.WHITE);
		favorites.setBackground(Color.WHITE);
		services.setBackground(Color.WHITE);
		this.add(discovery);
		this.add(favorites);
		this.add(services);
		discovery.addMouseListener(this);
		favorites.addMouseListener(this);
		services.addMouseListener(this);
//		discovery.addMouseListener(new MouseListener(){
//			public void mouseClicked(MouseEvent arg0) {
//				setPressed(Model.STATE_DISCOVERY);
//			}
//			public void mousePressed(MouseEvent arg0) {}
//			public void mouseReleased(MouseEvent arg0) {}
//			public void mouseEntered(MouseEvent arg0) {}
//			public void mouseExited(MouseEvent arg0) {}
//		});
//		favorites.addMouseListener(new MouseListener(){
//			public void mouseClicked(MouseEvent arg0) {
//				setPressed(Model.STATE_DISCOVERY);
//			}
//			public void mousePressed(MouseEvent arg0) {}
//			public void mouseReleased(MouseEvent arg0) {}
//			public void mouseEntered(MouseEvent arg0) {}
//			public void mouseExited(MouseEvent arg0) {}
//		});
//		services.addMouseListener(new MouseListener(){
//			public void mouseClicked(MouseEvent arg0) {
//				setPressed(Model.STATE_DISCOVERY);
//			}
//			public void mousePressed(MouseEvent arg0) {}
//			public void mouseReleased(MouseEvent arg0) {}
//			public void mouseEntered(MouseEvent arg0) {}
//			public void mouseExited(MouseEvent arg0) {}
//		});
	}

	private void setFalse() {
		discovery.setBorder(new LineBorder(Color.WHITE, 1));
		favorites.setBorder(new LineBorder(Color.WHITE, 1));
		services.setBorder(new LineBorder(Color.WHITE, 1));
	}

	private void setPressed(int state){
		model.setState(state);
	}

	public void propertyChange(PropertyChangeEvent arg0) {
		if(arg0.getPropertyName().equalsIgnoreCase("state")){
			Integer temp = (Integer)arg0.getNewValue();
			int newValue = temp.intValue();
			temp = (Integer)arg0.getOldValue();
			int oldValue = temp.intValue();
			setFalse();
			if(newValue==Model.STATE_DISCOVERY){
				discovery.setBorder(new LineBorder(Color.BLUE, 1));
			} else if(newValue==Model.STATE_FAVORITES){
				favorites.setBorder(new LineBorder(Color.BLUE, 1));
			} else if(newValue==Model.STATE_MYSERVICES){
				services.setBorder(new LineBorder(Color.BLUE, 1));
			}
			this.updateUI();
		}
	}

	public void mouseClicked(MouseEvent arg0) {
		if(arg0.getSource()==discovery){
			model.setState(Model.STATE_DISCOVERY);
		} else if(arg0.getSource()==favorites){
			model.setState(Model.STATE_FAVORITES);
		} else if(arg0.getSource()==services){
			model.setState(Model.STATE_MYSERVICES);
		}
	}

	public void mousePressed(MouseEvent arg0) {}
	public void mouseReleased(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	
}
