package copeServer.impl.gui;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import copeServer.impl.composition.Composition;
import copeServer.impl.composition.CompositionRegistry;
import copeServer.impl.composition.ComposedService;

public class SandboxButtonPanel extends JPanel implements PropertyChangeListener, ActionListener{

	private JButton initButton = new JButton("Initiate Composition");
	private JButton deleteBtn = new JButton("Delete Composition");
	private JButton removeServiceBtn = new JButton("Remove Service");
	
	private JCheckBox autoinit = new JCheckBox();
	private JLabel autoinitlbl = new JLabel("Automatically initiate");
	
	private CompositionRegistry compositionRegistry;
	private Composition selectedComposition;
	private ComposedService selectedRelation;
	private Model model;
	
	public SandboxButtonPanel(Model model, CompositionRegistry compositionRegistry) {
		this.model = model;
		this.compositionRegistry = compositionRegistry;
//		this.add(new JLabel("Sandbox"));
		this.model.addPropertyChangeListener(this);
		
		initButton.addActionListener(this);
		deleteBtn.addActionListener(this);
		removeServiceBtn.addActionListener(this);
		autoinit.addActionListener(this);
		autoinit.setSelected(model.getAutoinitiateCompositions());
		initButton.setEnabled(!model.getAutoinitiateCompositions());
		if(model.getSelectedRelation()==null)
			removeServiceBtn.setEnabled(false);
		
		this.setLayout(new GridLayout(1,2));
		
		JPanel left = new JPanel();
		left.setLayout(new BoxLayout(left, BoxLayout.PAGE_AXIS));
		left.add(initButton);
		left.add(deleteBtn);
		JPanel autoinitpanel = new JPanel();
		autoinitpanel.add(autoinitlbl);
		autoinitpanel.add(autoinit);
		left.add(autoinitpanel);
		
		JPanel right = new JPanel();
		right.setLayout(new BoxLayout(right, BoxLayout.PAGE_AXIS));
		right.add(removeServiceBtn);
		
		this.add(left);
		this.add(right);
		
		left.setBackground(Color.WHITE);
		autoinitpanel.setBackground(Color.WHITE);
		autoinit.setBackground(Color.WHITE);
		right.setBackground(Color.WHITE);
		this.setBackground(Color.WHITE);
		
	}

	public void propertyChange(PropertyChangeEvent arg0) {
		if(arg0.getPropertyName().equalsIgnoreCase("selectedcomposedservice")){
			if(model.getSelectedRelation()==null)
				this.removeServiceBtn.setEnabled(false);
			else
				this.removeServiceBtn.setEnabled(true);
		} else if(arg0.getPropertyName().equalsIgnoreCase("selectedrelation")){
			//TODO !!!
		} else if(arg0.getPropertyName().equalsIgnoreCase("selectedcomposition")){
			if(model.getSelectedComposition()==null)
				this.deleteBtn.setEnabled(false);
			else
				this.deleteBtn.setEnabled(true);
		}
	}

	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource()==initButton){
			model.getSelectedComposition().connectAll();
		} else if(arg0.getSource()==deleteBtn){
			compositionRegistry.removeComposition(selectedComposition);
		} else if(arg0.getSource()==autoinit){
			model.setAutoinitiateCompositions(autoinit.isSelected());
			this.initButton.setEnabled(!model.getAutoinitiateCompositions());
		} else if(arg0.getSource()==removeServiceBtn){
			model.getSelectedComposition().removeRelation(model.getSelectedRelation());
		}
	}
	
}
