package copeServer.impl.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.osgi.framework.Bundle;

import copeServer.impl.service.Service;

public class ServicesButtonPanel extends JPanel implements PropertyChangeListener, ActionListener{

	private JButton removebtn = new JButton("Remove");
	private JButton startbtn = new JButton("Start");
	private JButton stopbtn = new JButton("Stop");
	private JButton toSandbox = new JButton("To Sandbox");
	
	private Model model;
	
	public ServicesButtonPanel(Model model) {
		this.model = model;
		this.add(new JLabel("My Services"));
		model.addPropertyChangeListener(this);
//		model.getSelectedService().addPropertyChangeListener(this);
		setFalse();
		
		startbtn.addActionListener(this);
		stopbtn.addActionListener(this);
		removebtn.addActionListener(this);
		toSandbox.addActionListener(this);
		
		this.add(startbtn);
		this.add(stopbtn);
		this.add(removebtn);
		this.add(toSandbox);
		
	}

	private void setFalse() {
		startbtn.setEnabled(false);
		stopbtn.setEnabled(false);
		removebtn.setEnabled(false);
	}
	
	public void propertyChange(PropertyChangeEvent arg0) {
		if(arg0.getPropertyName().equalsIgnoreCase("selectedservice")){
			updateSelectedService();
		}
	}

	private void updateSelectedService() {
		setFalse();
		if(model.getSelectedService()!=null){
			if(model.getSelectedService().getState()==Bundle.INSTALLED){
				startbtn.setEnabled(true);
			} else if(model.getSelectedService().getState()==Bundle.RESOLVED){
				startbtn.setEnabled(true);
			} else if(model.getSelectedService().getState()==Bundle.ACTIVE){
				stopbtn.setEnabled(true);
			}
			if(model.getSelectedService()!=null){
				removebtn.setEnabled(true);
			}
		}
	}

	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource()==startbtn){
			model.getSelectedService().start();
		} else if(arg0.getSource()==stopbtn){
			model.getSelectedService().stop();
		} else if(arg0.getSource()==removebtn){
			model.getSelectedService().unregister();
		} else if(arg0.getSource()==toSandbox){
			System.out.println("Kaller models move2");
			model.moveServiceToSandbox();
		}
	}

}
