package copeServer.impl.gui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

import javax.swing.JList;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import copeServer.impl.service.Service;
import copeServer.impl.service.ServiceRegistry;

public class ServicesPanel extends JPanel{

	protected Image bgImage = null;
	
	private Model model;
	private ServiceRegistry serviceRegistry;
	
	private JList list;
	
	public ServicesPanel(Model model, ServiceRegistry serviceRegistry) {
		this.model = model;
		this.serviceRegistry = serviceRegistry;

		MediaTracker mt = new MediaTracker(this);                
		bgImage = Toolkit.getDefaultToolkit().getImage("COPE/myservicesback.jpg");
		mt.addImage(bgImage, 0);
		try{
			mt.waitForAll();
		}
		catch (InterruptedException e){
			e.printStackTrace();
		}
		
		init();
	}
	
	private void init() {
		list = new JList(serviceRegistry);
		list.setCellRenderer(new ServiceRenderer());
		list.setPreferredSize(new Dimension(250, 300));
		this.add(list);
		this.add(Box.createRigidArea(new Dimension(40, 40)));
		list.addListSelectionListener(new ListSelectionListener(){
			public void valueChanged(ListSelectionEvent arg0) {
				if(serviceRegistry.getSize()!=0){
					Service service = (Service) list.getSelectedValue();
					model.setSelectedService(service);
				} else{
					model.setSelectedService(null);
				}
			}
		});
		list.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent arg0){
				JList list = (JList)arg0.getSource();
				if(arg0.getClickCount()==2){
//					Service service = (Service) list.getSelectedValue();
//					service.openInterface();
					
					if(model.getSelectedService() != null)
						model.moveServiceToSandbox();
				}
			}
		});
	}

	protected void paintComponent(Graphics g){
		super.paintComponent(g);

		if(bgImage != null){
			int imwidth = bgImage.getWidth(null);
			int imheight = bgImage.getHeight(null);
			if((imwidth > 0) && (imheight > 0)){
				for(int y = 0; y<getHeight(); y+=imheight){
					for(int x = 0; x<getWidth(); x+=imwidth){
						g.drawImage(bgImage, x, y, null);
					}
				}
			}
		}
	}

}
