package copeServer.impl.service;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;

import org.osgi.framework.BundleContext;

public class ServiceRegistry extends AbstractListModel implements PropertyChangeListener{
	
	private BundleContext bundleContext;
	
	private List services = new ArrayList();
	//private List takenServiceID = new ArrayList();
	
	public ServiceRegistry(BundleContext context){
		this.bundleContext = context;
		//TODO: load registered services
		
	}
	
	public void addService(Service service){
		if(!services.contains(service)){
			services.add(service);
			service.addPropertyChangeListener(this);
			fireIntervalAdded(this, getSize(), getSize());
			System.out.println("Added new service: "+service);
		} else{
			System.out.println("ERROR ! Trying to add service that is allready there.");
		}
	}
	
	public void removeService(Service service){
		if(services.contains(service)){
			services.remove(service);
			service.removePropertyChangeListener(this);
			fireIntervalRemoved(this, 0, getSize());
			//takenServiceID.remove(new Integer(service.getID()));
			System.out.println("Removed service "+service);
		} else{
			System.out.println("ERROR ! Trying to remove service that is not there.");
		}
	}

	public void propertyChange(PropertyChangeEvent evt) {
		Service service = (Service)evt.getSource();
		if("url".equals(evt.getPropertyName()) || "state".equals(evt.getPropertyName())){
			int pos = services.indexOf(service);
			if (pos >= 0) {
				System.out.println("Fireing contentsChanged in position: "+pos);
				fireContentsChanged(this, pos, pos);
			} else{
				System.out.println("Error ! Wrong in position of service.");
			}
		} else{
			System.out.println("Error ! Property is not [url].");
		}
	}
	
	/*public int getAvailableServiceID(){
		int ret = 0;
		int last = 1;
		Integer tmp;
		for (int i = 0; i < getSize(); i++) {
			tmp = (Integer)takenServiceID.get(i);
			if(tmp.intValue()!=last){
				ret = last;
				takenServiceID.add(i, new Integer(last));
				return ret;
			} else{
				last = i;
			}
		}
		return ret;
	}*/
	
	public void saveRegistry(){
//		File file = new File("COPE/serviceregistry.txt");
//		try {
//			BufferedWriter bw = new BufferedWriter(new FileWriter(file));
//			for (int i = 0; i < services.size(); i++) {
//				Service service = (Service) services.get(i);
//				String write = service.getURL();
//			}
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
	}

	public int getSize() {
		return services.size();
	}

	public Object getElementAt(int pos) {
		return services.get(pos);
	}
	
	public Service getService(long id){
		Service service = null;
		for (int i = 0; i < getSize(); i++) {
			Service tmpservice = (Service) getElementAt(i);
			if(tmpservice.getID()==id)
				service = tmpservice;
		}
		return service;
	}

	public void pong(long source) {
		//TODO: recieve pong from source and renew that source's lifetime
		System.out.println("Recieved pong from "+source);
	}
	
}
