package copeProxy.impl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Properties;

import javax.xml.namespace.QName;

import org.apache.axis.client.Call;

import copeProxy.ServiceInterface;
import copeProxy.impl.ByteTools;


public class Service implements ServiceInterface{

	private String copeurl = "http://localhost:8080/axis/services/copeserver";
	private String serviceurl = "http://localhost:8080/axis/services/testservice";
	private String name = "Template Service";
	protected File icon;
	private long id;

	public Service(){
		
	}
	
	public void event(String description, Object oldValue, Object newValue) {
		System.out.println("Recieved command: event");
	}

	public void openInterface() {
		System.out.println("Recieved command: openInterface");
	}
	
	public Properties getDescription() {
		System.out.println("Recieved command: getDescription");
		return null;
	}

	public void connect(String description, String source, String target) {
		System.out.println("Recieved command: connect");
		try {
			String endpoint = serviceurl;
			
			org.apache.axis.client.Service  service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("connect"));
			
			call.invoke(new Object[]{description, source, target});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void disconnect(String description, String source, String target) {
		System.out.println("Recieved command: disconnect");
		try {
			String endpoint = serviceurl;
			
			org.apache.axis.client.Service  service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("disconnect"));
			
			call.invoke(new Object[]{description, source, target});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void setID(long id) {
		System.out.println("Recieved command: setID");
		this.id = id;
	}
	
	public void ping(){
		System.out.print("Recived ping");
		try {
			String endpoint = copeurl;
			
			org.apache.axis.client.Service  service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("pong"));
			System.out.println("Sending pong");
			
			call.invoke(new Object[]{new Long(id)});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void reRegisterWithCope(){
		System.out.println("Recieved command: reRegisterWithCope");
		try {
			String endpoint = copeurl;
			
			org.apache.axis.client.Service  service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();
			
			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("reRegisterService"));
			
			call.invoke(new Object[]{new Long(id)});
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getIconPath() {
		try {
			if (icon.exists())
				icon.delete();

			icon.createNewFile();

			FileInputStream fis = (FileInputStream) getClass().getResourceAsStream("/icon.png");
			
			FileOutputStream fos = new FileOutputStream(icon);
			
			int b;
			
			while ((b = fis.read()) != -1) {
				fos.write(b);
			}

			fos.flush();
			fos.close();

			fis.close();

			if (icon != null)
				return icon.getPath();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}
	
	public void setURL(String url) {
		// TODO Auto-generated method stub
		
	}
	
	public String getName() {
		System.out.println("Recieved command: getName");
		return name;
	}

	public String getURL() {
		return serviceurl;
	}

	
}
