package smsProxy.impl;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;

import smsProxy.ServiceInterface;

public class Service implements ServiceInterface {

	private String copeurl = "http://localhost:8080/axis/services/copeserver";

	private String serviceurl = "http://localhost:8080/axis/services/smsservice";

	private String name = "SMS Service";

	protected File icon;

	private long id;

	protected JFrame main;

	private JPanel holder;

	private String defaultMessage = "Type your message here";

	private JTextArea message = new JTextArea(defaultMessage);

	private String defaultNumber = "0047";

	private JTextField number = new JTextField(defaultNumber);

	private JButton sendButton = new JButton("Send");

	private JLabel statusLabel = new JLabel();

	public Service() {
		// setting correct IP address..
//		try {
//			Enumeration networkInterfaces = NetworkInterface.getNetworkInterfaces();
//			while (networkInterfaces.hasMoreElements()) {
//				NetworkInterface nic = (NetworkInterface) networkInterfaces.nextElement();
//				System.out.println("nic display name: " + nic.getDisplayName());
//				System.out.println("nic name: " + nic.getName());
//				Enumeration inetAddresses = nic.getInetAddresses();
//				while (inetAddresses.hasMoreElements()) {
//					InetAddress inet = (InetAddress) inetAddresses.nextElement();
//					String hostAddress = inet.getHostAddress();
//					if(hostAddress.startsWith("129.241.219")) {
//						serviceurl = "http://" + hostAddress + ":8080/axis/services/smsservice";
//						
//					}
//				}
//				
//			}
//		} catch (SocketException e) {
//			e.printStackTrace();
//		}
		
		System.out.println(serviceurl);
	}

	public void event(String description, Object oldValue, Object newValue) {
		System.out.println("Recieved command: event");
	}

	public void openInterface() {
		System.out.println("Recieved command: openInterface");

		Communicator.sendRequest(serviceurl, "ping", new Object[] {});

		main = new JFrame("SMS Sender");
		holder = new JPanel();
		holder.setLayout(new GridLayout(3, 2));
		holder.add(new JLabel("Text:"));
		holder.add(message);
		holder.add(new JLabel("Number:"));
		holder.add(number);
		holder.add(statusLabel);
		holder.add(sendButton);

		message.addKeyListener(new KeyListener() {

			public void keyTyped(KeyEvent e) {
				if (message.getText().length() > 160)
					message.setText(message.getText().substring(0, 159));
			}

			public void keyReleased(KeyEvent e) {
			}

			public void keyPressed(KeyEvent e) {
			}
		});

		number.addKeyListener(new KeyListener() {

			public void keyTyped(KeyEvent e) {
				if (number.getText().length() > 12)
					number.setText(number.getText().substring(0, 11));
			}

			public void keyReleased(KeyEvent e) {
			}

			public void keyPressed(KeyEvent e) {
			}
		});

		message.addFocusListener(new FocusListener() {
			public void focusLost(FocusEvent e) {
				if (message.getText().length() == 0)
					message.setText(defaultMessage);
			}

			public void focusGained(FocusEvent e) {
				if (message.getText().equals(defaultMessage))
					message.setText("");
			}
		});

		number.addFocusListener(new FocusListener() {
			public void focusLost(FocusEvent e) {
				if (number.getText().length() == 0)
					number.setText(defaultNumber);
			}

			public void focusGained(FocusEvent e) {
			}
		});

		sendButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					Long.parseLong(number.getText());
				} catch (Exception e1) {
					setStatus(number.getText() + " is not a valid number");
					return;
				}
				sendSMS();
				message.setText(defaultMessage);
				number.setText(defaultNumber);
			}
		});
		main.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		main.setContentPane(holder);
		main.pack();
		main.setVisible(true);
	}

	protected void setStatus(String string) {
		statusLabel.setText(string);
		new Thread(new Runnable() {
			public void run() {
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
				}
				statusLabel.setText("");
			}
		}).start();
	}

	protected void sendSMS() {

		try {
			org.apache.axis.client.Service service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();

			call.setTargetEndpointAddress(new URL(serviceurl));
			call.setOperationName(new QName("sendSms"));

			call.invoke(new Object[] { message.getText(), number.getText() });
		} catch (Exception e) {
			e.printStackTrace();
		}

		// Communicator.sendRequest(serviceurl, "sendSms", new Object[] {
		// message.getText(), number.getText() });
		holder.updateUI();
	}

	public Properties getDescription() {
		System.out.println("Recieved command: getDescription");
		
		Properties props = new Properties();
		props.put("connection.terminating.1", "smsconnection");
		
		return props;
	}

	public void connect(String description, String source, String target) {
		System.out.println("Recieved command: connect");
	}

	public void disconnect(String description, String source, String target) {
		System.out.println("Recieved command: disconnect");
	}

	public void setID(long id) {
		System.out.println("Recieved command: setID");
		this.id = id;
	}

	public void ping() {
		System.out.print("Recived ping");
		try {
			String endpoint = copeurl;

			org.apache.axis.client.Service service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();

			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("pong"));
			System.out.println("Sending pong");

			call.invoke(new Object[] { new Long(id) });
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void reRegisterWithCope() {
		System.out.println("Recieved command: reRegisterWithCope");
		try {
			String endpoint = copeurl;

			org.apache.axis.client.Service service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();

			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("reRegisterService"));

			call.invoke(new Object[] { new Long(id) });
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public String getIconPath() {
		try {
			if (icon.exists())
				icon.delete();

			icon.createNewFile();

			FileInputStream fis = (FileInputStream) getClass()
					.getResourceAsStream("/icon.png");
			FileOutputStream fos = new FileOutputStream(icon);
			int b;
			while ((b = fis.read()) != -1) {
				fos.write(b);
			}

			fos.flush();
			fos.close();

			fis.close();

			if (icon != null)
				return icon.getPath();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

	public void setURL(String url) {
		// TODO Auto-generated method stub

	}

	public String getName() {
		System.out.println("Recieved command: getName");
		return name;
	}

	public String getURL() {
		return serviceurl;
	}

}
