package soundProxy.impl;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowStateListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.Enumeration;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.xml.namespace.QName;

import org.apache.axis.client.Call;

import soundProxy.ServiceInterface;

public class Service implements ServiceInterface {

	private String copeurl = "http://localhost:8080/axis/services/copeserver";

	private String serviceurl = "http://localhost:8080/axis/services/soundservice";

	private String name = "Sound Service";

	protected File icon;

	private long id;

	JPanel holder;

	JFrame main;
	
	JComboBox combo = new JComboBox();
	
	JCheckBox checkBox = new JCheckBox("Chord", true);
	
	JButton send = new JButton("Send");

	JSlider aSlider = new JSlider(JSlider.VERTICAL, 0, 127, 64);

	JSlider bSlider = new JSlider(JSlider.VERTICAL, 0, 127, 64);

	JSlider cSlider = new JSlider(JSlider.VERTICAL, 0, 127, 64);

	public Service() {
		System.out.println(serviceurl);

		main = new JFrame("Sound Service");

		holder = new JPanel();
		holder.setLayout(new GridLayout(0, 1));

		JPanel sliderPanel = new JPanel();
		sliderPanel.setLayout(new GridLayout(0,3));
		sliderPanel.add(aSlider);
		sliderPanel.add(bSlider);
		sliderPanel.add(cSlider);
		
		holder.add(sliderPanel);
		
		JPanel restPanel = new JPanel();
		
		restPanel.add(checkBox);
		combo = new JComboBox((Object[])Communicator.sendRequest(serviceurl, "getInstruments", new Object[]{}));
		combo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
		        JComboBox cb = (JComboBox)e.getSource();
		        String instrument = (String)cb.getSelectedItem();
		        Communicator.sendRequest(serviceurl, "setInstrument", new Object[]{instrument});		
			}
		});
		restPanel.add(combo);
		
		restPanel.add(send);
		
		send.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {				
				Communicator.sendRequest(serviceurl, checkBox.isSelected()?"playChord":"playNotes", new Object[] { 
					new Integer(aSlider.getValue()),
					new Integer(bSlider.getValue()),
					new Integer(cSlider.getValue())});
			}
		});
		
		holder.add(restPanel);
		
		aSlider.setName("N1");
		bSlider.setName("N2");
		cSlider.setName("N3");

		aSlider.setPaintLabels(true);
		bSlider.setPaintLabels(true);
		cSlider.setPaintLabels(true);
	}

	public void event(String description, Object oldValue, Object newValue) {
		System.out.println("Recieved command: event");
	}

	public void openInterface() {
		System.out.println("Recieved command: openInterface");
		main.setContentPane(holder);
		main.setSize(300, 400);
		main.pack();
		main.setVisible(true);
	}

	public Properties getDescription() {
		System.out.println("Recieved command: getDescription");
		
		Properties props = new Properties();
		props.put("connection.terminating.1", "weatherconnection");
		props.put("connection.terminating.2", "chordconnection");
		props.put("connection.terminating.3", "noteconnection");
		props.put("connection.terminating.4", "notesconnection");
		props.put("connection.terminating.5", "musicconnection");
		
		return props;
	}

	public void connect(String description, String source, String target) {
		System.out.println("Recieved command: connect");
	}

	public void disconnect(String description, String source, String target) {
		System.out.println("Recieved command: disconnect");
	}

	public void setID(long id) {
		System.out.println("Recieved command: setID");
		this.id = id;
	}

	public void ping() {
		System.out.print("Recived ping");
		try {
			String endpoint = copeurl;

			org.apache.axis.client.Service service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();

			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("pong"));
			System.out.println("Sending pong");

			call.invoke(new Object[] { new Long(id) });
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void reRegisterWithCope() {
		System.out.println("Recieved command: reRegisterWithCope");
		try {
			String endpoint = copeurl;

			org.apache.axis.client.Service service = new org.apache.axis.client.Service();
			Call call = (Call) service.createCall();

			call.setTargetEndpointAddress(new URL(endpoint));
			call.setOperationName(new QName("reRegisterService"));

			call.invoke(new Object[] { new Long(id) });
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void setURL(String url) {
		serviceurl = url;
	}

	public String getName() {
		System.out.println("Recieved command: getName");
		return name;
	}

	public String getURL() {
		return serviceurl;
	}

	public String getIconPath() {
		try {
			if (icon.exists())
				icon.delete();

			icon.createNewFile();

			FileInputStream fis = (FileInputStream) getClass()
					.getResourceAsStream("/icon.png");
			FileOutputStream fos = new FileOutputStream(icon);
			int b;
			while ((b = fis.read()) != -1) {
				fos.write(b);
			}

			fos.flush();
			fos.close();

			fis.close();

			if (icon != null)
				return icon.getPath();

		} catch (IOException e) {
			e.printStackTrace();
		}

		return null;
	}

}
