package soundService;

public interface ServiceInterface {
	
	/**
	 * This method gets all available instruments
	 * 
	 * @return a String[] containing all available instruments
	 */
	public String[] getInstruments();
	
	/**
	 * This method sets the instrument to be used
	 * 
	 * @param instrument to be used
	 */
	public void setInstrument(String instrument);
	
	/**
	 * This method plays all three notes at the same time, as an chord
	 * 
	 * @param a
	 * @param b
	 * @param c
	 */
	public void playChord(int a, int b, int c);

	/**
	 * This method plays a and b for a quart and c for a half
	 * 
	 * @param a
	 * @param b
	 * @param c
	 */
	public void playNotes(int a, int b, int c);

	/**
	 * This method plays n for a half
	 * 
	 * @param n
	 */
	public void playNote(int n);

	/**
	 * This method play the sequence as is. If it's not compliant to JFugue's
	 * format, it will fail
	 * 
	 * @param sequence
	 */
	public void play(String sequence);

	/**
	 * This method lets the weather service connect to this service
	 * 
	 * @param headers
	 * @param values
	 */
	public void setWeatherData(String[] headers, String[] values);

}
