package soundService.impl;

import org.jfugue.Player;

import soundService.ServiceInterface;

public class Service implements ServiceInterface {

	int counter = 0;
	String curInstument = "Piano";
	MIDIInstruments instruments = new MIDIInstruments();

	public Service() {
	}
	
	public String[] getInstruments() {
		return instruments.getInstrumentNames();
	}

	public void setInstrument(String instrument) {
		curInstument = instruments.getInstrumentConstant(instrument);
	}
	
	public void playChord(int a, int b, int c) {
		a = adjust(a);
		b = adjust(b);
		c = adjust(c);

		if (counter < 5) {
			
			counter++;
			final String sequence = "I[" + curInstument + "] [" + a + "]+[" + b + "]+[" + c + "]w";
			
			new Thread(new Runnable() {
				public void run() {

					Player tempPlayer = new Player();
					tempPlayer.play(sequence);
					tempPlayer.close();
					counter--;
				}
			}).start();
		}
	}

	public void play(final String sequence) {
		if (counter < 5) {
			counter++;
			new Thread(new Runnable() {
				public void run() {

					Player tempPlayer = new Player();
					tempPlayer.play(sequence);
					tempPlayer.close();
					counter--;
				}
			}).start();
		}
	}

	public void playNote(int n) {
		final int n2 = adjust(n);
		if (counter < 5) {
			counter++;
			new Thread(new Runnable() {
				public void run() {

					Player tempPlayer = new Player();
					tempPlayer.play("I[" + curInstument + "] [" + n2 + "]");
					tempPlayer.close();
					counter--;
				}
			}).start();
		}
	}

	public void playNotes(int a, int b, int c) {
		a = adjust(a);
		b = adjust(b);
		c = adjust(c);

		if (counter < 5) {
			counter++;
			final String sequence = "I[" + curInstument + "] [" + a + "] [" + b + "] [" + c + "]w";
			
			new Thread(new Runnable() {
				public void run() {

					Player tempPlayer = new Player();
					tempPlayer.play(sequence);
					tempPlayer.close();
					counter--;
				}
			}).start();
		}
	}


	public void setWeatherData(String[] headers, String[] values) {
		String seqString = "";
		for (int i = 0; i < values.length; i++) {
			try {
				double parseDbl = Double.parseDouble(values[i]);
				seqString += (seqString.length()>0&&!seqString.endsWith(" ")?"+":"") + "[" + adjust((int) Math.round(parseDbl)) + "]";
				
				if(i%4 == 0)
					seqString += "w ";
				
			} catch (Exception e) {
				if(seqString.length()>0 && !seqString.endsWith(" "))
					seqString += " ";
			}
		}
		System.out.println("Generated string is: " + seqString);
		play("I[" + curInstument + "] " + seqString);
	}

	private int adjust(int n) {
		System.out.print("Adjusted " + n + " to ");
		
		/**
		 * If the value is larger than 127, we have to map it to the scale 0 -
		 * 127. The easiest way to do this is the following equation:
		 */
		// making sure it's not negative
		n = Math.abs(n);

		// only adjust if bigger than 127
		if (n > 127)
			n = (int) (Math.pow(127, 2) / n);

		// adjusting the note to a more pleasant sound
//		if(n < 63)
//			n += 63;
		
		System.out.print(n + "\n");

		return n;
	}
}
