package voiceProxy.impl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class ByteTools {

	public static byte[] getBytesFromFile(File file) throws IOException {
        InputStream is = new FileInputStream(file);
    
        // Get the size of the file
        long length = file.length();
    
        if (length > Integer.MAX_VALUE) {
            // File is too large
        }
    
        // Create the byte array to hold the data
        byte[] bytes = new byte[(int)length];
    
        // Read in the bytes
        int offset = 0;
        int numRead = 0;
        while (offset < bytes.length
               && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {
            offset += numRead;
        }
    
        // Ensure all the bytes have been read in
        if (offset < bytes.length) {
            throw new IOException("Could not completely read file "+file.getName());
        }
    
        // Close the input stream and return bytes
        is.close();
        return bytes;
    }
	
	public static File getFileFromBytes(String filename, byte[] bytes){
		File ret = null;
		try {
			ret = new File(filename);
			if(!ret.getParentFile().exists()){
				ret.getParentFile().mkdirs();
			}
			FileOutputStream of = new FileOutputStream(ret);
			of.write(bytes);
			of.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return ret;
	}
	
}
