package voiceProxy.impl;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import voiceProxy.ServiceInterface;

public class Service implements ServiceInterface {

	private String copeurl = "http://localhost:8080/axis/services/copeserver";

	private String serviceurl = "http://localhost:8080/axis/services/voiceservice";

	private String name = "Voice Service";

	protected File icon;

	private long id;

	protected JFrame main;

	private JPanel holder;

	private JTextField message = new JTextField(10);

	private JButton speakButton = new JButton("Speak");

	public Service() {
		System.out.println(serviceurl);
	}

	public void event(String description, Object oldValue, Object newValue) {
		System.out.println(getName() + " recieved command: event");
	}

	public void openInterface() {
		System.out.println(getName() + " recieved command: openInterface");
		
		main = new JFrame("Text-to-Speech Service");
		holder = new JPanel();
		holder.setLayout(new GridLayout(0, 2));
		holder.add(new JLabel("Text:"));
		holder.add(message);
		holder.add(new JLabel());
		holder.add(speakButton);

		speakButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				speak();
			}
		});
		
		main.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		main.setContentPane(holder);
		main.pack();
		main.setVisible(true);
	}


	protected void speak() {
		String text = message.getText().trim();
		
		System.out.println(getName() + " sending data to TTS: " + text);

		Communicator.sendRequest(serviceurl, "speak", new Object[] { text });
	}

	public Properties getDescription() {
		System.out.println(getName() + " recieved command: getDescription");
		
		Properties props = new Properties();
		props.put("connection.terminating.1", "ttsConnection");
		
		return props;
	}

	public void connect(String description, String source, String target) {
		System.out.println(getName() + " recieved command: connect");
	}

	public void disconnect(String description, String source, String target) {
		System.out.println(getName() + " recieved command: disconnect");
	}

	public void setID(long id) {
		System.out.println(getName() + " recieved command: setID");
		this.id = id;
	}

	public void ping() {
		System.out.print("Recived ping");
		Communicator.sendRequest(copeurl, "pong", new Object[] { new Long(id) });
	}

	public void reRegisterWithCope() {
		System.out.println(getName() + " recieved command: reRegisterWithCope");
		Communicator.sendRequest(copeurl, "reRegisterService", new Object[] { new Long(id) });
	}

	public String getIconPath() {
		try {
			if (icon.exists())
				icon.delete();

			icon.createNewFile();

			FileInputStream fis = (FileInputStream) getClass()
					.getResourceAsStream("/icon.png");
			FileOutputStream fos = new FileOutputStream(icon);
			int b;
			while ((b = fis.read()) != -1) {
				fos.write(b);
			}

			fos.flush();
			fos.close();

			fis.close();

			if (icon != null)
				return icon.getPath();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

	public void setURL(String url) {
		serviceurl = url;
	}

	public String getName() {
		return name;
	}

	public String getURL() {
		return serviceurl;
	}

}
