package voiceService.impl;

import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

import voiceService.ServiceInterface;

import com.sun.speech.freetts.Voice;
import com.sun.speech.freetts.VoiceManager;

public class Service implements ServiceInterface {

	public Service() {
		getVoices();
	}

	public String[] getVoices() {
		VoiceManager voiceManager = VoiceManager.getInstance();
		Voice[] voices = voiceManager.getVoices();
		String[] voiceNames = new String[voices.length];

		System.out.println("All voices available:");
		for (int i = 0; i < voices.length; i++) {
			System.out.println("\t" + voices[i].getName() + " (" + voices[i].getDomain() + " domain)");
			voiceNames[i] = voices[i].getName();
		}
		
		return voiceNames;
	}
	
	public void speak(String text) {

		System.out.println("About to say: " + text);

		try {
			Socket socket = new Socket("localhost", 1234);
			OutputStream outputStream = socket.getOutputStream();
			outputStream.write(text.getBytes(), 0, text.getBytes().length);
			outputStream.flush();
			outputStream.close();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
//		/*
//		 * The VoiceManager manages all the voices for FreeTTS.
//		 */
//		VoiceManager voiceManager = VoiceManager.getInstance();
//		System.out.println("The manager: " + voiceManager.toString());
//		Voice theVoice = voiceManager.getVoice("kevin16");
//		System.out.println("The voice: " + theVoice);
//		if (theVoice == null) {
//			System.err.println("Cannot find a voice.");
//			return;
//		}
//
//		/*
//		 * Allocates the resources for the voice.
//		 */
//		theVoice.allocate();
//
//		/*
//		 * Synthesize speech.
//		 */
//		theVoice.speak(text);
//
//		/*
//		 * Clean up and leave.
//		 */
//		theVoice.deallocate();
	}
}
