package weatherProxy.impl;

import java.util.Dictionary;
import java.util.Enumeration;
import java.util.Hashtable;

import org.osgi.framework.BundleContext;
import org.osgi.framework.Constants;
import org.osgi.framework.ServiceListener;
import org.osgi.framework.ServiceRegistration;
import org.osgi.service.cm.ConfigurationException;
import org.osgi.service.cm.ManagedService;

import weatherProxy.ServiceInterface;

public class ServiceManaged extends Service implements ManagedService {

	private Hashtable props;

	private ServiceRegistration registration;

	private ServiceListener sl;

	private String copeServiceFilter;

	private BundleContext context;

	public ServiceManaged(BundleContext context) {
		this.context = context;
		
		icon = context.getDataFile("/icon.png");

		props = new Hashtable();
		props.put(Constants.SERVICE_PID, "weatherProxy" + this.getClass().getName());
		props.put("SOAP.service.name", "weatherproxy");

	}

	public synchronized void open(BundleContext context) {
		System.out.print("Registering with framework... ");
		registration = context.registerService("weatherProxy.ServiceInterface",
				((ServiceInterface) this), props);
	}

	public void updated(Dictionary arg0) throws ConfigurationException {

	}

	/**
	 * Used for unloading the CoPE bundle Stores session
	 */
	public void unload() {
		registration.unregister();
		if (main != null)
			main.dispose();
	}

}
